/* file: minunit.h */
/* A minimal unit testing framework for C (improved)
 *
 * by Zhang Le <ejoy@users.sourceforge.net>
 *
 * This file is based on an article titled:
 * << MinUnit -- a minimal unit testing framework for C >>
 * which can be accessed from: http://www.jera.com/techinfo/jtns/jtn002.html
 *
 * The orignal mu_assert can not report failed experssion and filename
 * information. This improved version solves this problem. You can still use
 * the old one by calling mu_assert2
 *
 * Last Change :22-Aug-2004.
 */

#ifndef _MINUNIT_H
#define _MINUNIT_H

#include <string.h> /* for sprintf */

#define mu_assert(test) do { if (!(test))  {  return #test "failed at line"  "[__LINE__] of "  __FILE__ ; } } while (0)
#define mu_assert2(message, test) do { if (!(test)) return message; } while (0) 
#define mu_run_test(test) do { char *message = test(); tests_run++;  if (message) return message; } while (0)
extern int tests_run;

#endif /* _MINUNIT_H */
